=begin
(c) TIG 2011
---
RelazioneFacce.rb
---
To use type 'relazionefacce' in the Ruby Console.
It makes a report of all selected faces.
By Reference, Orientation, Area [sqm to 2 dp] and Material.
This is printed in the Ruby Console.
If the SKP has been saved a TSV file is made with it and it is 
automatically opened.
Note that all text is in Italian.
---
Per utilizzare scrivere 'relazionefacce' nella Console di Ruby.
Si fa un report di tutte le facce selezionate.
Con Riferimento, Orientamento, Area [mq a 2 dp] e Materiale.
Questo  stampato nella Console di Ruby.
Se il SKP  stato salvato un file TSV  fatto con esso e si apre 
automaticamente.
Notare che tutto il testo  in italiano.
---
Donations by PayPal to info @ revitrev.org
---
Version 1.0 20110203 First Issue.
=end
require 'sketchup.rb'
###
class RelazioneFacce
 def initialize()
  model=Sketchup.active_model
  ss=model.selection
  faces=[]; ss.each{|e|faces << e if e.class==Sketchup::Face}
  if not faces[0]
    UI.beep
    puts "Senza facce sono stati selezionati!\nRiprovare...\n\nUscita..."
    puts
    return nil
  end#if
  text="FACCIA\tORIENAMENTO\tAREA mq\tMATERIALE\n"
  faces.each{|face|
    name=face.to_s.split(":")[-1].split(">")[0]
    norm=face.normal
    if norm.z.abs >= 0.999
      orin="Oriz"
    else
      ang = Y_AXIS.angle_between(norm)
      ang = -ang if norm.x < 0
      if ang >= -22.5.degrees and ang <= 22.5.degrees
        orin="N"
      elsif ang > 22.5.degrees and ang < 67.5.degrees
        orin="NE"
      elsif ang >= 67.5.degrees and ang <= 112.5.degrees
        orin="E"
      elsif ang > 112.5.degrees and ang < 157.5.degrees
        orin="SE"
      elsif ang >= 157.5.degrees or ang <= -157.5.degrees
        orin="S"
      elsif ang > -157.5.degrees and ang < -112.5.degrees
        orin="SO"
      elsif ang >= -112.5.degrees and ang <= -67.5.degrees
        orin="O"
      elsif ang > -67.5.degrees and ang < -22.5.degrees
        orin="NO"
      else
        orin="Errore"
      end#if
    end#if
    area=sprintf("%.2f", face.area * 0.00064516).to_s.tr(".",",")
    matl="<Default>"; matl=face.material.display_name if face.material
    text = text+name+"\t"+orin+"\t"+area+"\t"+matl+"\n"
  }
  puts text
  if model.path and model.path != ""
    title=model.title
    name=title+"_Facce.TSV"
    filepath=File.join(File.dirname(model.path), name).tr("\\","/")
    begin
      file=File.new(filepath,"w")
    rescue
      UI.beep
      puts "Il file chiamato '"+filepath+"' non pu essere scritta!\nProbabilmente  gi aperta.\nRiprovare...\n\nUscita..."
      puts
	  return nil
    end
    file.puts(text)
    file.close
    puts "\nVedi File '"+filepath+"'"
    sleep(1)
    UI.openURL(filepath)
  else
    UI.beep
    puts "\nNessun file TSV pu essere fatta, a meno che la SKP viene salvato!"
  end#if
  puts
  return nil
 end#def
end#class
###
def relazionefacce()
  RelazioneFacce.new()
  return nil
end#if
###